/*----- PROTECTED REGION ID(RfCav.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        RfCav.cpp
//
// description : C++ source for the RfCav class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               RfCav are implemented in this file.
//
//
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include "RfCav.h"
#include "RfCavClass.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfCav.cpp

/**
 *  RfCav class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//  PumpOn        |  pump_on
//  PumpOff       |  pump_off
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  inPwr              |  Tango::DevDouble	Scalar
//  posit              |  Tango::DevDouble	Scalar
//  rflPwr             |  Tango::DevDouble	Scalar
//  vlt                |  Tango::DevDouble	Scalar
//  inRange            |  Tango::DevBoolean	Scalar
//  vacuumInterlock    |  Tango::DevBoolean	Scalar
//  h2oSecFlow         |  Tango::DevDouble	Scalar
//  h2oRemote          |  Tango::DevBoolean	Scalar
//  h2oOn              |  Tango::DevBoolean	Scalar
//  h2oResistor11On    |  Tango::DevBoolean	Scalar
//  h2oResistor12On    |  Tango::DevBoolean	Scalar
//  h2oPrimaryFlowLow  |  Tango::DevBoolean	Scalar
//================================================================

namespace RfCav_ns
{
/*----- PROTECTED REGION ID(RfCav::namespace_starting) ENABLED START -----*/
/* clang-format on */
double calibrate(const std::vector<Tango::DevDouble> &calibration,
		const double &value)
{
	return calibration[0] * value * value * value + \
		calibration[1] * value * value + \
		calibration[2] * value + \
		calibration[3];
}
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfCav::namespace_starting

//--------------------------------------------------------
/**
 *	Method     : RfCav::RfCav()
 *	Description: Constructors for a Tango device
 *                implementing the classRfCav
 */
//--------------------------------------------------------
RfCav::RfCav(Tango::DeviceClass *cl, std::string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(RfCav::constructor_1) ENABLED START -----*/
	/* clang-format on */
	init_device();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::constructor_1
}
//--------------------------------------------------------
RfCav::RfCav(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(RfCav::constructor_2) ENABLED START -----*/
	/* clang-format on */
	init_device();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::constructor_2
}
//--------------------------------------------------------
RfCav::RfCav(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(RfCav::constructor_3) ENABLED START -----*/
	/* clang-format on */
	init_device();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::constructor_3
}
//--------------------------------------------------------
RfCav::~RfCav()
{
	delete_device();
}

//--------------------------------------------------------
/**
 *	Method     : RfCav::delete_device()
 *	Description: will be called at device destruction or at init command
 */
//--------------------------------------------------------
void RfCav::delete_device()
{
	DEBUG_STREAM << "RfCav::delete_device() " << device_name << std::endl;
	/*----- PROTECTED REGION ID(RfCav::delete_device) ENABLED START -----*/
	/* clang-format on */
	//	Delete device allocated objects
	if (vltADC)
		delete vltADC;
	if (inpwrADC)
		delete inpwrADC;
	if (rflpwrADC)
		delete rflpwrADC;
	if (positADC)
		delete positADC;
	if (h2osecflowADC)
		delete h2osecflowADC;

	if (inRangeDIO)
		delete inRangeDIO;
	if (vacuumInterlockDIO)
		delete vacuumInterlockDIO;
	if (pumpOnOffDIO)
		delete pumpOnOffDIO;
	if (h2oRemoteDIO)
		delete h2oRemoteDIO;
	if (h2oOnDIO)
		delete h2oOnDIO;
	if (h2oResistor11OnDIO)
		delete h2oResistor11OnDIO;
	if (h2oResistor12OnDIO)
		delete h2oResistor12OnDIO;
	if (h2oPrimaryFlowLowDIO)
		delete h2oPrimaryFlowLowDIO;
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::delete_device
	delete[] attr_inPwr_read;
	delete[] attr_posit_read;
	delete[] attr_rflPwr_read;
	delete[] attr_vlt_read;
	delete[] attr_inRange_read;
	delete[] attr_vacuumInterlock_read;
	delete[] attr_h2oSecFlow_read;
	delete[] attr_h2oRemote_read;
	delete[] attr_h2oOn_read;
	delete[] attr_h2oResistor11On_read;
	delete[] attr_h2oResistor12On_read;
	delete[] attr_h2oPrimaryFlowLow_read;
}

//--------------------------------------------------------
/**
 *	Method     : RfCav::init_device()
 *	Description: will be called at device initialization.
 */
//--------------------------------------------------------
void RfCav::init_device()
{
	DEBUG_STREAM << "RfCav::init_device() create device " << device_name << std::endl;
	/*----- PROTECTED REGION ID(RfCav::init_device_before) ENABLED START -----*/
	/* clang-format on */
	initError.clear();
	vltADC = inpwrADC = rflpwrADC = positADC = NULL;
	inRangeDIO = vacuumInterlockDIO = NULL;
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::init_device_before


	//	Get the device properties from database
	get_device_property();

	attr_inPwr_read = new Tango::DevDouble[1];
	attr_posit_read = new Tango::DevDouble[1];
	attr_rflPwr_read = new Tango::DevDouble[1];
	attr_vlt_read = new Tango::DevDouble[1];
	attr_inRange_read = new Tango::DevBoolean[1];
	attr_vacuumInterlock_read = new Tango::DevBoolean[1];
	attr_h2oSecFlow_read = new Tango::DevDouble[1];
	attr_h2oRemote_read = new Tango::DevBoolean[1];
	attr_h2oOn_read = new Tango::DevBoolean[1];
	attr_h2oResistor11On_read = new Tango::DevBoolean[1];
	attr_h2oResistor12On_read = new Tango::DevBoolean[1];
	attr_h2oPrimaryFlowLow_read = new Tango::DevBoolean[1];
	//	No longer if mandatory property not set.
	if (mandatoryNotDefined)
		return;

	/*----- PROTECTED REGION ID(RfCav::init_device) ENABLED START -----*/
	/* clang-format on */
		
	//	Initialize device

	try {
		vltADC = new ADC(vltDevice);
		inpwrADC = new ADC(inpwrDevice);
		rflpwrADC = new ADC(rflpwrDevice);
		positADC = new ADC(positDevice);
		h2osecflowADC = new ADC(secFlowDevice);

		inRangeDIO = new DIO(inRangeDevice);
		vacuumInterlockDIO = new DIO(vacuumInterlockDevice);
	    	pumpOnOffDIO = new DIO(pumpOnOffDevice);
	    	h2oRemoteDIO = new DIO(h2oRemoteDevice);
		h2oOnDIO = new DIO(h2oOnDevice);
	    	h2oResistor11OnDIO = new DIO(h2oResistor11OnDevice);
		h2oResistor12OnDIO = new DIO(h2oResistor12OnDevice);
		h2oPrimaryFlowLowDIO = new DIO(h2oPrimaryFlowLowDevice);
		
		check_state();

	} catch (Tango::DevFailed &e) {
		initError = "Initialization failed: " + string(e.errors[0].desc);
	} catch (...) {
		initError = "Initialization failed: Unknown error";
	}

	if (! initError.empty()) {
		ERROR_STREAM << initError << endl;
		set_state(Tango::UNKNOWN);
		set_status(initError);
		assert(false);
	}

	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::init_device
}

//--------------------------------------------------------
/**
 *	Method     : RfCav::get_device_property()
 *	Description: Read database to initialize property data members.
 */
//--------------------------------------------------------
void RfCav::get_device_property()
{
	/*----- PROTECTED REGION ID(RfCav::get_device_property_before) ENABLED START -----*/
	/* clang-format on */
	//	Initialize property data members
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::get_device_property_before

	mandatoryNotDefined = false;

	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("VltDevice"));
	dev_prop.push_back(Tango::DbDatum("VltCalibration"));
	dev_prop.push_back(Tango::DbDatum("InpwrDevice"));
	dev_prop.push_back(Tango::DbDatum("InpwrCalibration"));
	dev_prop.push_back(Tango::DbDatum("RflpwrDevice"));
	dev_prop.push_back(Tango::DbDatum("RflpwrCalibration"));
	dev_prop.push_back(Tango::DbDatum("PositDevice"));
	dev_prop.push_back(Tango::DbDatum("PositCalibration"));
	dev_prop.push_back(Tango::DbDatum("InRangeDevice"));
	dev_prop.push_back(Tango::DbDatum("vacuumInterlockDevice"));
	dev_prop.push_back(Tango::DbDatum("PumpOnOffDevice"));
	dev_prop.push_back(Tango::DbDatum("SecFlowDevice"));
	dev_prop.push_back(Tango::DbDatum("SecFlowCalibration"));
	dev_prop.push_back(Tango::DbDatum("H2oRemoteDevice"));
	dev_prop.push_back(Tango::DbDatum("H2oOnDevice"));
	dev_prop.push_back(Tango::DbDatum("H2oResistor11OnDevice"));
	dev_prop.push_back(Tango::DbDatum("H2oResistor12OnDevice"));
	dev_prop.push_back(Tango::DbDatum("H2oPrimaryFlowLowDevice"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);

		//	get instance on RfCavClass to get class property
		Tango::DbDatum	def_prop, cl_prop;
		RfCavClass	*ds_class =
			(static_cast<RfCavClass *>(get_device_class()));
		int	i = -1;

		//	Try to initialize VltDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  vltDevice;
		else {
			//	Try to initialize VltDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  vltDevice;
		}
		//	And try to extract VltDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  vltDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize VltCalibration from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  vltCalibration;
		else {
			//	Try to initialize VltCalibration from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  vltCalibration;
		}
		//	And try to extract VltCalibration value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  vltCalibration;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize InpwrDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  inpwrDevice;
		else {
			//	Try to initialize InpwrDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  inpwrDevice;
		}
		//	And try to extract InpwrDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  inpwrDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize InpwrCalibration from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  inpwrCalibration;
		else {
			//	Try to initialize InpwrCalibration from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  inpwrCalibration;
		}
		//	And try to extract InpwrCalibration value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  inpwrCalibration;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize RflpwrDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  rflpwrDevice;
		else {
			//	Try to initialize RflpwrDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  rflpwrDevice;
		}
		//	And try to extract RflpwrDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  rflpwrDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize RflpwrCalibration from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  rflpwrCalibration;
		else {
			//	Try to initialize RflpwrCalibration from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  rflpwrCalibration;
		}
		//	And try to extract RflpwrCalibration value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  rflpwrCalibration;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize PositDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  positDevice;
		else {
			//	Try to initialize PositDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  positDevice;
		}
		//	And try to extract PositDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  positDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize PositCalibration from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  positCalibration;
		else {
			//	Try to initialize PositCalibration from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  positCalibration;
		}
		//	And try to extract PositCalibration value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  positCalibration;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize InRangeDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  inRangeDevice;
		else {
			//	Try to initialize InRangeDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  inRangeDevice;
		}
		//	And try to extract InRangeDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  inRangeDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize vacuumInterlockDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  vacuumInterlockDevice;
		else {
			//	Try to initialize vacuumInterlockDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  vacuumInterlockDevice;
		}
		//	And try to extract vacuumInterlockDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  vacuumInterlockDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize PumpOnOffDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  pumpOnOffDevice;
		else {
			//	Try to initialize PumpOnOffDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  pumpOnOffDevice;
		}
		//	And try to extract PumpOnOffDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  pumpOnOffDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize SecFlowDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  secFlowDevice;
		else {
			//	Try to initialize SecFlowDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  secFlowDevice;
		}
		//	And try to extract SecFlowDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  secFlowDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize SecFlowCalibration from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  secFlowCalibration;
		else {
			//	Try to initialize SecFlowCalibration from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  secFlowCalibration;
		}
		//	And try to extract SecFlowCalibration value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  secFlowCalibration;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize H2oRemoteDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  h2oRemoteDevice;
		else {
			//	Try to initialize H2oRemoteDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  h2oRemoteDevice;
		}
		//	And try to extract H2oRemoteDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  h2oRemoteDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize H2oOnDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  h2oOnDevice;
		else {
			//	Try to initialize H2oOnDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  h2oOnDevice;
		}
		//	And try to extract H2oOnDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  h2oOnDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize H2oResistor11OnDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  h2oResistor11OnDevice;
		else {
			//	Try to initialize H2oResistor11OnDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  h2oResistor11OnDevice;
		}
		//	And try to extract H2oResistor11OnDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  h2oResistor11OnDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize H2oResistor12OnDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  h2oResistor12OnDevice;
		else {
			//	Try to initialize H2oResistor12OnDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  h2oResistor12OnDevice;
		}
		//	And try to extract H2oResistor12OnDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  h2oResistor12OnDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize H2oPrimaryFlowLowDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  h2oPrimaryFlowLowDevice;
		else {
			//	Try to initialize H2oPrimaryFlowLowDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  h2oPrimaryFlowLowDevice;
		}
		//	And try to extract H2oPrimaryFlowLowDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  h2oPrimaryFlowLowDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

	}

	/*----- PROTECTED REGION ID(RfCav::get_device_property_after) ENABLED START -----*/
	/* clang-format on */
	//	Check device property data members init
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::get_device_property_after
}
//--------------------------------------------------------
/**
 *	Method     : RfCav::check_mandatory_property()
 *	Description: For mandatory properties check if defined in database.
 */
//--------------------------------------------------------
void RfCav::check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop)
{
	//	Check if all properties are empty
	if (class_prop.is_empty() && dev_prop.is_empty())
	{
		TangoSys_OMemStream	tms;
		tms << std::endl <<"Property \'" << dev_prop.name;
		if (Tango::Util::instance()->_UseDb==true)
			tms << "\' is mandatory but not defined in database";
		else
			tms << "\' is mandatory but cannot be defined without database";
		append_status(tms.str());
		mandatoryNotDefined = true;
		/*----- PROTECTED REGION ID(RfCav::check_mandatory_property) ENABLED START -----*/
		/* clang-format on */
		std::cerr << tms.str() << " for " << device_name << std::endl;
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	RfCav::check_mandatory_property
	}
}


//--------------------------------------------------------
/**
 *	Method     : RfCav::always_executed_hook()
 *	Description: method always executed before any command is executed
 */
//--------------------------------------------------------
void RfCav::always_executed_hook()
{
	DEBUG_STREAM << "RfCav::always_executed_hook()  " << device_name << std::endl;
	if (mandatoryNotDefined)
	{
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					get_status().c_str(),
					(const char *)"RfCav::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(RfCav::always_executed_hook) ENABLED START -----*/
	/* clang-format on */
	if (! initError.empty()) {
		ERROR_STREAM << initError << endl;
		set_status(initError);
		set_state(Tango::UNKNOWN);
		assert(false);
		return;
	}

	try {
		check_state();
	} catch(Tango::DevFailed &e) {
		ERROR_STREAM << string(e.errors[0].desc) << endl;
		set_state(Tango::UNKNOWN);
		set_status(string(e.errors[0].desc));
		assert(false);
	}

	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method     : RfCav::read_attr_hardware()
 *	Description: Hardware acquisition for attributes
 */
//--------------------------------------------------------
void RfCav::read_attr_hardware(TANGO_UNUSED(std::vector<long> &attr_list))
{
	DEBUG_STREAM << "RfCav::read_attr_hardware(std::vector<long> &attr_list) entering... " << std::endl;
	/*----- PROTECTED REGION ID(RfCav::read_attr_hardware) ENABLED START -----*/
	/* clang-format on */
	check_init();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::read_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute inPwr related method
 *	Description: input power kW
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RfCav::read_inPwr(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RfCav::read_inPwr(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(RfCav::read_inPwr) ENABLED START -----*/
	/* clang-format on */
	short adc = inpwrADC->readRaw();
	ostringstream dbgmsg;
	dbgmsg << "RfCav::read_inPwr(): ADC raw, dec = " << dec << adc \
		<< ", hex = 0x" << hex << adc << flush;
	DEBUG_STREAM << dbgmsg.str() << std::endl;
	attr_inPwr_read[0] = calibrate(inpwrCalibration, adc);
	dbgmsg.str("");
	dbgmsg << "RfCav::read_inPwr(): ADC calibrated, dec = " << dec \
		<< attr_inPwr_read[0] << flush;
	DEBUG_STREAM << dbgmsg.str() << std::endl;
	attr.set_value(attr_inPwr_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::read_inPwr
}
//--------------------------------------------------------
/**
 *	Read attribute posit related method
 *	Description: tuning position
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RfCav::read_posit(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RfCav::read_posit(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(RfCav::read_posit) ENABLED START -----*/
	/* clang-format on */
	short adc = positADC->readRaw();
	ostringstream dbgmsg;
	dbgmsg << "RfCav::read_posit(): ADC raw, dec = " << dec << adc \
                << ", hex = 0x" << hex << adc << flush;
	DEBUG_STREAM << dbgmsg.str() << std::endl;
	attr_posit_read[0] = calibrate(positCalibration, adc);
	dbgmsg.str("");
        dbgmsg << "RfCav::read_posit(): ADC calibrated, dec = " << dec \
                << attr_posit_read[0] << flush;
        DEBUG_STREAM << dbgmsg.str() << std::endl;
	attr.set_value(attr_posit_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::read_posit
}
//--------------------------------------------------------
/**
 *	Read attribute rflPwr related method
 *	Description: reflected power kW
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RfCav::read_rflPwr(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RfCav::read_rflPwr(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(RfCav::read_rflPwr) ENABLED START -----*/
	/* clang-format on */
	short adc = rflpwrADC->readRaw();
	ostringstream dbgmsg;
        dbgmsg << "RfCav::read_rflPwr(): ADC raw, dec = " << dec << adc \
                << ", hex = 0x" << hex << adc << flush;
        DEBUG_STREAM << dbgmsg.str() << std::endl;
	attr_rflPwr_read[0] = calibrate(rflpwrCalibration, adc);
	dbgmsg.str("");
        dbgmsg << "RfCav::read_rflPwr(): ADC calibrated, dec = " << dec \
                << attr_rflPwr_read[0] << flush;
        DEBUG_STREAM << dbgmsg.str() << std::endl;
	attr.set_value(attr_rflPwr_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::read_rflPwr
}
//--------------------------------------------------------
/**
 *	Read attribute vlt related method
 *	Description: gap voltage kV
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RfCav::read_vlt(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RfCav::read_vlt(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(RfCav::read_vlt) ENABLED START -----*/
	/* clang-format on */
	short adc = vltADC->readRaw();
	ostringstream dbgmsg;
        dbgmsg << "RfCav::read_vlt(): ADC raw, dec = " << dec << adc \
                << ", hex = 0x" << hex << adc << flush;
        DEBUG_STREAM << dbgmsg.str() << std::endl;
	attr_vlt_read[0] = calibrate(vltCalibration, adc);
	dbgmsg.str("");
        dbgmsg << "RfCav::read_vlt(): ADC calibrated, dec = " << dec \
                << attr_vlt_read[0] << flush;
        DEBUG_STREAM << dbgmsg.str() << std::endl;
	attr.set_value(attr_vlt_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::read_vlt
}
//--------------------------------------------------------
/**
 *	Read attribute inRange related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RfCav::read_inRange(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RfCav::read_inRange(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(RfCav::read_inRange) ENABLED START -----*/
	/* clang-format on */
	attr_inRange_read[0] = inRangeDIO->read();
	attr.set_value(attr_inRange_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::read_inRange
}
//--------------------------------------------------------
/**
 *	Read attribute vacuumInterlock related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RfCav::read_vacuumInterlock(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RfCav::read_vacuumInterlock(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(RfCav::read_vacuumInterlock) ENABLED START -----*/
	/* clang-format on */
	attr_vacuumInterlock_read[0] = !vacuumInterlockDIO->read();
	attr.set_value(attr_vacuumInterlock_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::read_vacuumInterlock
}
//--------------------------------------------------------
/**
 *	Read attribute h2oSecFlow related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RfCav::read_h2oSecFlow(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RfCav::read_h2oSecFlow(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(RfCav::read_h2oSecFlow) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr_h2oSecFlow_read[0] = calibrate(secFlowCalibration, h2osecflowADC->readRaw());
	attr.set_value(attr_h2oSecFlow_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::read_h2oSecFlow
}
//--------------------------------------------------------
/**
 *	Read attribute h2oRemote related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RfCav::read_h2oRemote(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RfCav::read_h2oRemote(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(RfCav::read_h2oRemote) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr_h2oRemote_read[0] = h2oRemoteDIO->read();
	attr.set_value(attr_h2oRemote_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::read_h2oRemote
}
//--------------------------------------------------------
/**
 *	Read attribute h2oOn related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RfCav::read_h2oOn(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RfCav::read_h2oOn(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(RfCav::read_h2oOn) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr_h2oOn_read[0] = h2oOnDIO->read();
	attr.set_value(attr_h2oOn_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::read_h2oOn
}
//--------------------------------------------------------
/**
 *	Read attribute h2oResistor11On related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RfCav::read_h2oResistor11On(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RfCav::read_h2oResistor11On(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(RfCav::read_h2oResistor11On) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr_h2oResistor11On_read[0] = h2oResistor11OnDIO->read();
	attr.set_value(attr_h2oResistor11On_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::read_h2oResistor11On
}
//--------------------------------------------------------
/**
 *	Read attribute h2oResistor12On related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RfCav::read_h2oResistor12On(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RfCav::read_h2oResistor12On(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(RfCav::read_h2oResistor12On) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr_h2oResistor12On_read[0] = h2oResistor12OnDIO->read();
	attr.set_value(attr_h2oResistor12On_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::read_h2oResistor12On
}
//--------------------------------------------------------
/**
 *	Read attribute h2oPrimaryFlowLow related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void RfCav::read_h2oPrimaryFlowLow(Tango::Attribute &attr)
{
	DEBUG_STREAM << "RfCav::read_h2oPrimaryFlowLow(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(RfCav::read_h2oPrimaryFlowLow) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr_h2oPrimaryFlowLow_read[0] = !h2oPrimaryFlowLowDIO->read();
	attr.set_value(attr_h2oPrimaryFlowLow_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::read_h2oPrimaryFlowLow
}

//--------------------------------------------------------
/**
 *	Method     : RfCav::add_dynamic_attributes()
 *	Description: Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void RfCav::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(RfCav::add_dynamic_attributes) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code to create and add dynamic attributes if any
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command PumpOn related method
 *
 *
 */
//--------------------------------------------------------
void RfCav::pump_on()
{
	DEBUG_STREAM << "RfCav::PumpOn()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(RfCav::pump_on) ENABLED START -----*/
	/* clang-format on */

	//	Add your own code
	check_init();
	pumpOnOffDIO->write(1);

	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::pump_on
}
//--------------------------------------------------------
/**
 *	Command PumpOff related method
 *
 *
 */
//--------------------------------------------------------
void RfCav::pump_off()
{
	DEBUG_STREAM << "RfCav::PumpOff()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(RfCav::pump_off) ENABLED START -----*/
	/* clang-format on */

	//	Add your own code
	check_init();
	pumpOnOffDIO->write(0);

	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::pump_off
}
//--------------------------------------------------------
/**
 *	Method     : RfCav::add_dynamic_commands()
 *	Description: Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void RfCav::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(RfCav::add_dynamic_commands) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code to create and add dynamic commands if any
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCav::add_dynamic_commands
}

/*----- PROTECTED REGION ID(RfCav::namespace_ending) ENABLED START -----*/
/* clang-format on */
void RfCav::check_init()
{
	if (! initError.empty())
		Tango::Except::throw_exception( "",
				initError.c_str(),
				"RfCav::check_init()");
}

void RfCav::check_state()
{
	attr_inRange_read[0] = inRangeDIO->read();
	attr_vacuumInterlock_read[0] = vacuumInterlockDIO->read();
	attr_h2oOn_read[0] = h2oOnDIO->read();
	/*
	if (attr_inRange_read[0] || attr_vacuumInterlock_read[0]) {
		set_state(Tango::ALARM);
		set_status("The device is in ALARM state");
	} else {
		set_state(Tango::OFF);
		set_status("The device is in OFF state");
	}
	*/
	set_state(Tango::ON);
	set_status("The device is in ON state");
}

/*----- PROTECTED REGION END -----*/	//	RfCav::namespace_ending
} //	namespace
