/*----- PROTECTED REGION ID(RfCavClass.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        RfCavClass.cpp
//
// description : C++ source for the RfCavClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the RfCav once per process.
//
//
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include "RfCavClass.h"
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfCavClass.cpp

//-------------------------------------------------------------------
/**
 *	Create RfCavClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_RfCav_class(const char *name) {
		return RfCav_ns::RfCavClass::init(name);
	}
}

namespace RfCav_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
RfCavClass *RfCavClass::_instance = NULL;

//===================================================================
//	Class constants
//===================================================================
//--------------------------------------------------------
/**
 * method : 		RfCavClass::RfCavClass(std::string &s)
 * description : 	constructor for the RfCavClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
RfCavClass::RfCavClass(std::string &s):Tango::DeviceClass(s)
{
	TANGO_LOG_INFO << "Entering RfCavClass constructor" << std::endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(RfCavClass::constructor) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCavClass::constructor

	TANGO_LOG_INFO << "Leaving RfCavClass constructor" << std::endl;
}

//--------------------------------------------------------
/**
 * method : 		RfCavClass::~RfCavClass()
 * description : 	destructor for the RfCavClass
 */
//--------------------------------------------------------
RfCavClass::~RfCavClass()
{
	/*----- PROTECTED REGION ID(RfCavClass::destructor) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCavClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		RfCavClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
RfCavClass *RfCavClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			std::string s(name);
			_instance = new RfCavClass(s);
		}
		catch (std::bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		RfCavClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
RfCavClass *RfCavClass::instance()
{
	if (_instance == NULL)
	{
		std::cerr << "Class is not initialized !!" << std::endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		PumpOnClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *PumpOnClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "PumpOnClass::execute(): arrived" << std::endl;
	((static_cast<RfCav *>(device))->pump_on());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		PumpOffClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *PumpOffClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "PumpOffClass::execute(): arrived" << std::endl;
	((static_cast<RfCav *>(device))->pump_off());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method     : RfCavClass::get_class_property()
 *	Description: Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum RfCavClass::get_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : RfCavClass::get_default_device_property()
 *	Description: Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum RfCavClass::get_default_device_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : RfCavClass::get_default_class_property()
 *	Description: Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum RfCavClass::get_default_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method     : RfCavClass::set_default_property()
 *	Description: Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void RfCavClass::set_default_property()
{
	std::string	prop_name;
	std::string	prop_desc;
	std::string	prop_def;
	std::vector<std::string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "VltDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "VltCalibration";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "InpwrDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "InpwrCalibration";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "RflpwrDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "RflpwrCalibration";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "PositDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "PositCalibration";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "InRangeDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "vacuumInterlockDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "PumpOnOffDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "SecFlowDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "SecFlowCalibration";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "H2oRemoteDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "H2oOnDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "H2oResistor11OnDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "H2oResistor12OnDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "H2oPrimaryFlowLowDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method     : RfCavClass::write_class_property()
 *	Description: Set class description fields as property in database
 */
//--------------------------------------------------------
void RfCavClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	std::string	classname = get_name();
	std::string	header;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	std::string	str_title("");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	std::vector<std::string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	std::vector<std::string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method     : RfCavClass::device_factory()
 *	Description: Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void RfCavClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(RfCavClass::device_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCavClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		TANGO_LOG_DEBUG << "Device name : " << (*devlist_ptr)[i].in() << std::endl;
		device_list.push_back(new RfCav(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		RfCav *dev = static_cast<RfCav *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(RfCavClass::device_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCavClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : RfCavClass::attribute_factory()
 *	Description: Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void RfCavClass::attribute_factory(std::vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(RfCavClass::attribute_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCavClass::attribute_factory_before
	//	Attribute : inPwr
	inPwrAttrib	*inpwr = new inPwrAttrib();
	Tango::UserDefaultAttrProp	inpwr_prop;
	inpwr_prop.set_description("input power kW");
	//	label	not set for inPwr
	//	unit	not set for inPwr
	//	standard_unit	not set for inPwr
	//	display_unit	not set for inPwr
	//	format	not set for inPwr
	//	max_value	not set for inPwr
	//	min_value	not set for inPwr
	//	max_alarm	not set for inPwr
	//	min_alarm	not set for inPwr
	//	max_warning	not set for inPwr
	//	min_warning	not set for inPwr
	//	delta_t	not set for inPwr
	//	delta_val	not set for inPwr
	inpwr->set_default_properties(inpwr_prop);
	//	Not Polled
	inpwr->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(inpwr);

	//	Attribute : posit
	positAttrib	*posit = new positAttrib();
	Tango::UserDefaultAttrProp	posit_prop;
	posit_prop.set_description("tuning position");
	//	label	not set for posit
	//	unit	not set for posit
	//	standard_unit	not set for posit
	//	display_unit	not set for posit
	//	format	not set for posit
	//	max_value	not set for posit
	//	min_value	not set for posit
	//	max_alarm	not set for posit
	//	min_alarm	not set for posit
	//	max_warning	not set for posit
	//	min_warning	not set for posit
	//	delta_t	not set for posit
	//	delta_val	not set for posit
	posit->set_default_properties(posit_prop);
	//	Not Polled
	posit->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(posit);

	//	Attribute : rflPwr
	rflPwrAttrib	*rflpwr = new rflPwrAttrib();
	Tango::UserDefaultAttrProp	rflpwr_prop;
	rflpwr_prop.set_description("reflected power kW");
	//	label	not set for rflPwr
	//	unit	not set for rflPwr
	//	standard_unit	not set for rflPwr
	//	display_unit	not set for rflPwr
	//	format	not set for rflPwr
	//	max_value	not set for rflPwr
	//	min_value	not set for rflPwr
	//	max_alarm	not set for rflPwr
	//	min_alarm	not set for rflPwr
	//	max_warning	not set for rflPwr
	//	min_warning	not set for rflPwr
	//	delta_t	not set for rflPwr
	//	delta_val	not set for rflPwr
	rflpwr->set_default_properties(rflpwr_prop);
	//	Not Polled
	rflpwr->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(rflpwr);

	//	Attribute : vlt
	vltAttrib	*vlt = new vltAttrib();
	Tango::UserDefaultAttrProp	vlt_prop;
	vlt_prop.set_description("gap voltage kV");
	//	label	not set for vlt
	//	unit	not set for vlt
	//	standard_unit	not set for vlt
	//	display_unit	not set for vlt
	//	format	not set for vlt
	//	max_value	not set for vlt
	//	min_value	not set for vlt
	//	max_alarm	not set for vlt
	//	min_alarm	not set for vlt
	//	max_warning	not set for vlt
	//	min_warning	not set for vlt
	//	delta_t	not set for vlt
	//	delta_val	not set for vlt
	vlt->set_default_properties(vlt_prop);
	//	Not Polled
	vlt->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(vlt);

	//	Attribute : inRange
	inRangeAttrib	*inrange = new inRangeAttrib();
	Tango::UserDefaultAttrProp	inrange_prop;
	//	description	not set for inRange
	//	label	not set for inRange
	//	unit	not set for inRange
	//	standard_unit	not set for inRange
	//	display_unit	not set for inRange
	//	format	not set for inRange
	//	max_value	not set for inRange
	//	min_value	not set for inRange
	//	max_alarm	not set for inRange
	//	min_alarm	not set for inRange
	//	max_warning	not set for inRange
	//	min_warning	not set for inRange
	//	delta_t	not set for inRange
	//	delta_val	not set for inRange
	inrange->set_default_properties(inrange_prop);
	//	Not Polled
	inrange->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(inrange);

	//	Attribute : vacuumInterlock
	vacuumInterlockAttrib	*vacuuminterlock = new vacuumInterlockAttrib();
	Tango::UserDefaultAttrProp	vacuuminterlock_prop;
	//	description	not set for vacuumInterlock
	//	label	not set for vacuumInterlock
	//	unit	not set for vacuumInterlock
	//	standard_unit	not set for vacuumInterlock
	//	display_unit	not set for vacuumInterlock
	//	format	not set for vacuumInterlock
	//	max_value	not set for vacuumInterlock
	//	min_value	not set for vacuumInterlock
	//	max_alarm	not set for vacuumInterlock
	//	min_alarm	not set for vacuumInterlock
	//	max_warning	not set for vacuumInterlock
	//	min_warning	not set for vacuumInterlock
	//	delta_t	not set for vacuumInterlock
	//	delta_val	not set for vacuumInterlock
	vacuuminterlock->set_default_properties(vacuuminterlock_prop);
	//	Not Polled
	vacuuminterlock->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(vacuuminterlock);

	//	Attribute : h2oSecFlow
	h2oSecFlowAttrib	*h2osecflow = new h2oSecFlowAttrib();
	Tango::UserDefaultAttrProp	h2osecflow_prop;
	//	description	not set for h2oSecFlow
	//	label	not set for h2oSecFlow
	//	unit	not set for h2oSecFlow
	//	standard_unit	not set for h2oSecFlow
	//	display_unit	not set for h2oSecFlow
	//	format	not set for h2oSecFlow
	//	max_value	not set for h2oSecFlow
	//	min_value	not set for h2oSecFlow
	//	max_alarm	not set for h2oSecFlow
	//	min_alarm	not set for h2oSecFlow
	//	max_warning	not set for h2oSecFlow
	//	min_warning	not set for h2oSecFlow
	//	delta_t	not set for h2oSecFlow
	//	delta_val	not set for h2oSecFlow
	h2osecflow->set_default_properties(h2osecflow_prop);
	//	Not Polled
	h2osecflow->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(h2osecflow);

	//	Attribute : h2oRemote
	h2oRemoteAttrib	*h2oremote = new h2oRemoteAttrib();
	Tango::UserDefaultAttrProp	h2oremote_prop;
	//	description	not set for h2oRemote
	//	label	not set for h2oRemote
	//	unit	not set for h2oRemote
	//	standard_unit	not set for h2oRemote
	//	display_unit	not set for h2oRemote
	//	format	not set for h2oRemote
	//	max_value	not set for h2oRemote
	//	min_value	not set for h2oRemote
	//	max_alarm	not set for h2oRemote
	//	min_alarm	not set for h2oRemote
	//	max_warning	not set for h2oRemote
	//	min_warning	not set for h2oRemote
	//	delta_t	not set for h2oRemote
	//	delta_val	not set for h2oRemote
	h2oremote->set_default_properties(h2oremote_prop);
	//	Not Polled
	h2oremote->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(h2oremote);

	//	Attribute : h2oOn
	h2oOnAttrib	*h2oon = new h2oOnAttrib();
	Tango::UserDefaultAttrProp	h2oon_prop;
	//	description	not set for h2oOn
	//	label	not set for h2oOn
	//	unit	not set for h2oOn
	//	standard_unit	not set for h2oOn
	//	display_unit	not set for h2oOn
	//	format	not set for h2oOn
	//	max_value	not set for h2oOn
	//	min_value	not set for h2oOn
	//	max_alarm	not set for h2oOn
	//	min_alarm	not set for h2oOn
	//	max_warning	not set for h2oOn
	//	min_warning	not set for h2oOn
	//	delta_t	not set for h2oOn
	//	delta_val	not set for h2oOn
	h2oon->set_default_properties(h2oon_prop);
	//	Not Polled
	h2oon->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(h2oon);

	//	Attribute : h2oResistor11On
	h2oResistor11OnAttrib	*h2oresistor11on = new h2oResistor11OnAttrib();
	Tango::UserDefaultAttrProp	h2oresistor11on_prop;
	//	description	not set for h2oResistor11On
	//	label	not set for h2oResistor11On
	//	unit	not set for h2oResistor11On
	//	standard_unit	not set for h2oResistor11On
	//	display_unit	not set for h2oResistor11On
	//	format	not set for h2oResistor11On
	//	max_value	not set for h2oResistor11On
	//	min_value	not set for h2oResistor11On
	//	max_alarm	not set for h2oResistor11On
	//	min_alarm	not set for h2oResistor11On
	//	max_warning	not set for h2oResistor11On
	//	min_warning	not set for h2oResistor11On
	//	delta_t	not set for h2oResistor11On
	//	delta_val	not set for h2oResistor11On
	h2oresistor11on->set_default_properties(h2oresistor11on_prop);
	//	Not Polled
	h2oresistor11on->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(h2oresistor11on);

	//	Attribute : h2oResistor12On
	h2oResistor12OnAttrib	*h2oresistor12on = new h2oResistor12OnAttrib();
	Tango::UserDefaultAttrProp	h2oresistor12on_prop;
	//	description	not set for h2oResistor12On
	//	label	not set for h2oResistor12On
	//	unit	not set for h2oResistor12On
	//	standard_unit	not set for h2oResistor12On
	//	display_unit	not set for h2oResistor12On
	//	format	not set for h2oResistor12On
	//	max_value	not set for h2oResistor12On
	//	min_value	not set for h2oResistor12On
	//	max_alarm	not set for h2oResistor12On
	//	min_alarm	not set for h2oResistor12On
	//	max_warning	not set for h2oResistor12On
	//	min_warning	not set for h2oResistor12On
	//	delta_t	not set for h2oResistor12On
	//	delta_val	not set for h2oResistor12On
	h2oresistor12on->set_default_properties(h2oresistor12on_prop);
	//	Not Polled
	h2oresistor12on->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(h2oresistor12on);

	//	Attribute : h2oPrimaryFlowLow
	h2oPrimaryFlowLowAttrib	*h2oprimaryflowlow = new h2oPrimaryFlowLowAttrib();
	Tango::UserDefaultAttrProp	h2oprimaryflowlow_prop;
	//	description	not set for h2oPrimaryFlowLow
	//	label	not set for h2oPrimaryFlowLow
	//	unit	not set for h2oPrimaryFlowLow
	//	standard_unit	not set for h2oPrimaryFlowLow
	//	display_unit	not set for h2oPrimaryFlowLow
	//	format	not set for h2oPrimaryFlowLow
	//	max_value	not set for h2oPrimaryFlowLow
	//	min_value	not set for h2oPrimaryFlowLow
	//	max_alarm	not set for h2oPrimaryFlowLow
	//	min_alarm	not set for h2oPrimaryFlowLow
	//	max_warning	not set for h2oPrimaryFlowLow
	//	min_warning	not set for h2oPrimaryFlowLow
	//	delta_t	not set for h2oPrimaryFlowLow
	//	delta_val	not set for h2oPrimaryFlowLow
	h2oprimaryflowlow->set_default_properties(h2oprimaryflowlow_prop);
	//	Not Polled
	h2oprimaryflowlow->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(h2oprimaryflowlow);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(RfCavClass::attribute_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCavClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : RfCavClass::pipe_factory()
 *	Description: Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void RfCavClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(RfCavClass::pipe_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCavClass::pipe_factory_before
	/*----- PROTECTED REGION ID(RfCavClass::pipe_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCavClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : RfCavClass::command_factory()
 *	Description: Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void RfCavClass::command_factory()
{
	/*----- PROTECTED REGION ID(RfCavClass::command_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCavClass::command_factory_before


	//	Command PumpOn
	PumpOnClass	*pPumpOnCmd =
		new PumpOnClass("PumpOn",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pPumpOnCmd);

	//	Command PumpOff
	PumpOffClass	*pPumpOffCmd =
		new PumpOffClass("PumpOff",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pPumpOffCmd);

	/*----- PROTECTED REGION ID(RfCavClass::command_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCavClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		RfCavClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the created attribute list
 */
//--------------------------------------------------------
void RfCavClass::create_static_attribute_list(std::vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		std::string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	TANGO_LOG_INFO << defaultAttList.size() << " attributes in default list" << std::endl;

	/*----- PROTECTED REGION ID(RfCavClass::create_static_att_list) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCavClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		RfCavClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void RfCavClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, std::vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((std::string)(*devlist_ptr)[i]).c_str());
		RfCav *dev = static_cast<RfCav *> (dev_impl);

		std::vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		std::vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			std::string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			std::vector<std::string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				TANGO_LOG_INFO << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << std::endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(RfCavClass::erase_dynamic_attributes) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCavClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method     : RfCavClass::get_attr_object_by_name()
 *	Description: returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *RfCavClass::get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname)
{
	std::vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(RfCavClass::Additional Methods) ENABLED START -----*/
/* clang-format on */
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfCavClass::Additional Methods
} //	namespace
